Home | History | Annotate | Download | only in move
      1 #!/bin/bash
      2 
      3 #
      4 # Copyright (c) International Business Machines  Corp., 2005
      5 # Author: Avantika Mathur (mathurav (at] us.ibm.com)
      6 #
      7 # This library is free software; you can redistribute it and/or
      8 # modify it under the terms of the GNU Lesser General Public
      9 # License as published by the Free Software Foundation; either
     10 # version 2.1 of the License, or (at your option) any later version.
     11 #
     12 # This library is distributed in the hope that it will be useful,
     13 # but WITHOUT ANY WARRANTY; without even the implied warranty of
     14 # MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
     15 # Lesser General Public License for more details.
     16 #
     17 # You should have received a copy of the GNU Lesser General Public
     18 # License along with this library; if not, write to the Free Software
     19 # Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
     20 #
     21 
     22 SETS_DEFAULTS="${TCID=test17} ${TST_COUNT=1} ${TST_TOTAL=1}"
     23 declare -r TCID
     24 declare -r TST_COUNT
     25 declare -r TST_TOTAL
     26 export TCID TST_COUNT TST_TOTAL
     27 
     28 tst_resm TINFO "***************TEST17***************"
     29 tst_resm TINFO "move: tree with shared parent"
     30 tst_resm TINFO "************************************"
     31 
     32 . "${FS_BIND_ROOT}/bin/setup" || (tst_resm TWARN "Setup of move/test17 failed" && tst_exit)
     33 export result=0
     34 
     35 
     36 
     37 trap 'ERR=$? ; ERR_MSG="caught error near: ${BASH_SOURCE[0]}:${FUNCNAME[0]}:${LINENO}:$_ (returned ${ERR})"; break' ERR
     38 
     39 while /bin/true ; do
     40 	# This loop is for error recovery purposes only
     41 
     42 
     43 	"${FS_BIND_ROOT}/bin/makedir" share parent1
     44 	"${FS_BIND_ROOT}/bin/makedir" share parent1/child1
     45 	"${FS_BIND_ROOT}/bin/makedir" share parent2
     46 
     47 	mkdir parent2/child2
     48 
     49 	mount --move parent1/child1 parent2/child2 2> /dev/null || result=$?
     50 
     51 	break
     52 done
     53 trap 'ERR=$? ; tst_resm TWARN "move/test17: caught error near: ${BASH_SOURCE[0]}:${FUNCNAME[0]}:${LINENO}:$_ (returned ${ERR})"' ERR
     54 if [ -n "${ERR_MSG}" ]; then
     55 	tst_resm TWARN "move/test17: ${ERR_MSG}"
     56 	ERR_MSG=""
     57 	result=$ERR
     58 fi
     59 trap '' ERR
     60 {
     61 	umount parent1/child1 # if the move failed
     62 	umount parent2/child2 # if the move succeeded
     63 	umount parent2
     64 	umount parent1
     65 
     66 	rm -rf dir parent* share*
     67 	cleanup
     68 } >& /dev/null
     69 if [ $result -eq 0 ]
     70 then
     71 	tst_resm TFAIL "move/test17: FAILED: move: tree with shared parent - check ERROR."
     72 	exit 1
     73 else
     74 	tst_resm TPASS "move/test17: PASSED"
     75 	exit 0
     76 fi
     77 tst_exit
     78